select
    an.numero -- Nmero
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as Grau_Sangue -- Grau de sangue
    , an.dtnascimento as Data_Nasc -- Data de nascimento
    , (case
        when concep.cdtiporeproducao = 3 then (parto.data - concep.data + 7)
        when concep.cdtiporeproducao in (1,2) then (parto.data - concep.data)
        else null end) as Duracao_Gestacao -- Durao da Gestao
    , (case concep.cdtiporeproducao
        when 1 then 'IA'
        when 2 then 'COB'
        when 3 then (case c.tipocoleta
                     when 1 then 'FIV'
                     when 2 then 'TE'
                     else 'FIV/TE' end)
        else null end) as Origem -- Tipo de Concepcao
    , (select tp.descricao from tipoparto tp where tp.cdtipoparto = parto.cdtipoparto) as Tipo_parto -- Parto normal ou distorcido
    , (select ap.descricao from auxilioparto ap where ap.cdauxilioparto = parto.cdauxilioparto) as Grau_Distorcia -- Grau distorcia
    , (select first 1 peso from peso p where p.cdanimal = an.cdanimal order by p.dtpeso asc) as Peso_Nasc -- Peso nascimento
    , (case
        when an.dtdesmama is null then null
        else (select (sp1.meses || ' mes(s) ' || sp1.dias || ' dia(s)')
            from sp_idadeanimal ('DESMAMA', 'where cdanimal = ' || an.cdanimal) sp1)
        end) as Idade_Desmama -- Idade Desmama
    , (select first 1 p.peso from peso p where p.cdanimal = an.cdanimal and p.dtpeso = an.dtdesmama) as Peso_Desm -- Peso Desmama
    , (case
        when exists (select *
            from doencaanimal da
            where da.cdanimal = an.cdanimal
                and da.cddoenca in (select cddoenca from doenca d where (upper(d.nomeresumido) like '%TRISTEZA%') or (upper(d.nomeresumido) like 'ANAPLASMOSE')))
        then 'Sim'
        else 'No' end) as Teve_Tristeza-- Teve ou no tristeza
    , (select count(*)
        from doencaanimal da
        where da.cdanimal = an.cdanimal
            and da.cddoenca in (select cddoenca from doenca d where (upper(d.nomeresumido) like '%TRISTEZA%') or (upper(d.nomeresumido) like 'ANAPLASMOSE'))) as Casos_Tristeza-- Nmero de casos de tristeza
    , (case
        when exists (select *
            from doencaanimal da
            where da.cdanimal = an.cdanimal
                and da.cddoenca = (select cddoenca from doenca d where upper(d.nomeresumido) like 'PNEUMONIA'))
        then 'Sim'
        else 'No' end) as Teve_Pneumonia -- Teve ou no pneumonia
    , (select count(*)
        from doencaanimal da
        where da.cdanimal = an.cdanimal
            and da.cddoenca = (select cddoenca from doenca d where upper(d.nomeresumido) like 'PNEUMONIA')) as Casos_Pneumonia -- Nmero de casos de pneumonia
    , (select min(da.dtinicio)
        from doencaanimal da
        where da.cdanimal = an.cdanimal
            and da.cddoenca in (select cddoenca from doenca d where (upper(d.nomeresumido) like '%TRISTEZA%') or (upper(d.nomeresumido) like 'ANAPLASMOSE'))) as Primeira_Tristeza -- Data do 1 caso de tristeza
    , (select min(da.dtinicio)
        from doencaanimal da
        where da.cdanimal = an.cdanimal
            and da.cddoenca = (select cddoenca from doenca d where upper(d.nomeresumido) like 'PNEUMONIA')) as Primeira_Pneumonia -- Data 1 caso  de pneumonia
    , (select min(rep.data)
        from reproducao rep
        where rep.cdanimal = an.cdanimal
            and rep.cdtiporeproducao in (1,2,3)) as Primeira_IA -- Data 1 IA (novilha)
    , (select count(*)
        from reproducao rep
        where rep.data < (select first 1 dig.data
                            from reproducao dig
                            where dig.cdanimal = rep.cdanimal
                                and dig.diagnostico = 'P'
                            order by dig.data asc)
            and rep.cdtiporeproducao in (1,2,3)
            and rep.cdanimal = an.cdanimal) as Doses_Concepcao -- Nmero de doses para a concepo (novilha)
    , an.dtbaixa  as Baixa -- Data de baixa
    , (select tp.descricao from tipobaixa tp where tp.cdtipobaixa = an.cdtipobaixa) as Tipo_baixa-- Tipo de baixa
    , (select mb.descricao from motivobaixa mb where mb.cdmotivobaixa = an.cdmotivobaixa) as Motivo_baixa-- Motivo
    , par1.data as Primeiro_Parto -- Data 1 parto
    , (select ap.descricao from auxilioparto ap where ap.cdauxilioparto = par1.cdauxilioparto) as Aux_Parto -- Dificuldade no parto e intensidade
    , (case par1.retencaoplacenta
        when 1 then 'Sim'
        when 0 then 'No'
        else null end) as Rent_Placenta-- Reteno de placenta 1 cria
    , (select first 1 p.peso from peso p where p.dtpeso = par1.data and p.cdanimal = an.cdanimal) as Peso_Prim_Parto -- Peso ao 1 parto
    , (select first 1 p.peso
        from peso p
        where p.cdanimal = (select first 1 an2.cdanimal from animal an2 where an2.cdmae = an.cdanimal and an2.dtnascimento = par1.data)
        order by p.dtpeso asc) as Peso_Prim_Cria -- Peso da cria (1 parto)
    ,  (select count(*)
        from reproducao rep
        where rep.data < par1.data
            and rep.cdtiporeproducao in (1,2,3)
            and rep.cdanimal = an.cdanimal) as Doses_Prim_Cria -- Nmero de doses para a concepo (1 cria)
    , (tent2.data - par1.data) as Servico_Prim_Cria-- Perodo de servio 1a cria
    , (select producao305 from sp_producao305(lac1.cdlactacao)) as Producao_305_Prim_Cria -- Produo 305 dias (1 )
    , lac1.dtfim as Secagem_Prim_Cria-- Data secagem 1a cria
    , (select ms.descricao from motivosecagem ms where ms.cdmotivosecagem = lac1.cdmotivosecagem) as Motivo_Sec_Prim_Cria -- Motivo secagem 1a cria
    , (select producao305 from sp_producao305(lac2.cdlactacao)) as Producao_305_Seg_Cria -- Produo 305 dias (2 )
    , par2.data as Data_Seg_Cria -- Data parto 2 cria
    , lac2.dtfim as Sec_Seg_Cria -- Data secagem 2 cria
    , (select ms.descricao from motivosecagem ms where ms.cdmotivosecagem = lac2.cdmotivosecagem) as Motivo_Sec_Seg_Cria -- Motivo secagem 2 cria
    , ea.dtexame as Data_Colostragem -- Exame de Colostragem
    , ea.valor as Resultado_Colostragem -- Exame de Colostragem
from animal an
    left join reproducao nasc on nasc.cdreproducao =
        (case
            when an.cdreproducao is null then (select first 1 re.cdreproducao
                                                from reproducao re
                                                where re.cdanimal = an.cdmae
                                                    and re.data = an.dtnascimento
                                                    and cdtiporeproducao = 7)
            else an.cdreproducao end)
    left join reproducao concep on concep.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re
            where re.cdanimal = coalesce(nasc.cdanimal,(select cdanimal from reproducao where cdembriao = an.cdanimal))
                and re.data < an.dtnascimento
                and re.cdtiporeproducao in (1,2,3)
            order by re.data desc)
    left join reproducao parto on parto.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = concep.cdanimal
                and re.data > concep.data
                and re.cdtiporeproducao = 7
            order by re.data asc)
    left join reproducao par1 on par1.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
            order by re.data asc)
    left join reproducao par2 on par2.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao = 7
                and re.data > par1.data
            order by re.data asc)
    left join reproducao udigp on udigp.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.diagnostico = 'P'
                and re.data > par1.data
            order by re.data desc)
    left join reproducao tent2 on tent2.cdreproducao =
        (select first 1 re.cdreproducao
            from reproducao re
            where re.cdanimal = an.cdanimal
                and re.cdtiporeproducao in (1,2,3)
                and re.data between par1.data and coalesce(par2.data, udigp.data)
            order by re.data desc)
    left join lactacao lac1 on lac1.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.dtinicio = par1.data and re.cdanimal = an.cdanimal)
    left join lactacao lac2 on lac2.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.dtinicio = par2.data and re.cdanimal = an.cdanimal)
    left join exameanimal ea on ea.cdexameanimal =
        (select first 1 ree.cdexameanimal
            from exameanimal ree
            where ree.cdanimal = an.cdanimal
                and ree.cdexame = (select cdexame from exame where descricao = 'Colostragem')
            order by ree.dtexame desc)
    left join coleta c on c.cdcoleta = concep.cdcoleta
where an.tipoanimal = 'A'
    and an.animalrebanho = 1
    and an.sexo = 'F'
--    and an.cdsetor = 2 -- SE HOUVER INTERESSE  POSSIVEL RETIRAR ESTE COMENTRIO E FILTRAR SETOR
order by an.numordenado

